// invisible char:--     -----

function Device(name, isConnected)
{
	this.name = name;
	this.isConnected = isConnected;
}

function LineDevice(line, device)
{
	this.line = line;
	this.device = device;
}

function LineBus(line, bus)
{
	this.line = line;
	this.bus = bus;
}

function BootDevice(line, device)
{
	this.line = line;
	this.device = device;
}

var devConnected = new Array();
devConnected[0] = new Device("Keyboard", true);
devConnected[1] = new Device("Mouse", false);
devConnected[2] = new Device("Printer", false);
devConnected[3] = new Device("Scanner", false);

var list_states;
var list_of_buses = new Array();
var list_of_devices = new Array();
var list_of_boot_devices = new Array();
var list_of_basic_devices = new Array();

var cookies;
var scale = 0;
var currentLine = 0;
var currentBus = -1;
var currentState = -1;
var currentDevice = -1;
var bootDevice = "NONE";

var english = 0;

var algorithm = new Array();
algorithm[0] =  " booting_the_computer()";
algorithm[1] =  " {";
algorithm[2] =  "   installed_RAM_size = memory_testing();";
algorithm[3] =  "   for each (device) in (list_of_basic_devices)";
algorithm[4] =  "     if (is_connected(device) == true)";
algorithm[5] =  "       test_device(device);";
algorithm[6] =  "   for each (bus) in (list_of_buses)";
algorithm[7] =  "     if (connected_device(bus) == NEW_DEVICE)";
algorithm[8] =  "       configure_device(bus);";
algorithm[9] =  "   boot_device = null;";
algorithm[10] = "  found_device = false;";
algorithm[11] = "  while (!found_device)";
algorithm[12] = "  {";
algorithm[13] = "    for each (device) in (list_of_boot_devices)";
algorithm[14] = "    {";
algorithm[15] = "      if (attempt_to_boot(device) == true)";
algorithm[16] = "      {";
algorithm[17] = "        boot_device = device;";
algorithm[18] = "        found_device = true;";
algorithm[19] = "        break;";
algorithm[20] = "      }";
algorithm[21] = "    }";
algorithm[22] = "    if (!found_device)";
algorithm[23] = "    {";
algorithm[24] = "      print(\"No boot device was found.\");";
algorithm[25] = "      print(\"Try again when a boot device is connected.\");";
algorithm[26] = "      //ask if there's any boot device connected";
algorithm[27] = "    }";
algorithm[28] = "  }";
algorithm[29] = "  load_boot_sector(boot_device);";
algorithm[30] = "  boot_loader = search_active_partition(boot_device);";
algorithm[31] = "  data = get_configuration_information(BIOS);";
algorithm[32] = "  init_OS(boot_loader, data);";
algorithm[33] = "  for each (device) in (list_of_devices)";
algorithm[34] = "    if (driver(device) != INSTALLED)";
algorithm[35] = "      print(\"Install the driver from: CD-ROM or Internet.\");";
algorithm[36] = "  load_in_kernel(drivers);";
algorithm[37] = "  initialize_essential_resources();";
algorithm[38] = "}";

var getBootDevice = function()
{
	bootDevice = document.getElementById("form-bootdevice").bootdevice.value;
	document.cookie = "bootDev=" + bootDevice;
}

var getConnectedDevices = function()
{
	devConnected[0].isConnected = document.getElementById("form-devices").keyboard.checked;
	devConnected[2].isConnected = document.getElementById("form-devices").printer.checked;
	devConnected[3].isConnected = document.getElementById("form-devices").scanner.checked;
	devConnected[1].isConnected = document.getElementById("form-devices").mouse.checked;
	document.cookie = "dev1=" + devConnected[0].isConnected;
	document.cookie = "dev2=" + devConnected[1].isConnected;
	document.cookie = "dev3=" + devConnected[2].isConnected;
	document.cookie = "dev4=" + devConnected[3].isConnected;
	document.cookie = "path=/";
	cookies = document.cookie;
}

var selectedConfiguration = function()
{
	if(location.href.split("/").slice(-1) == "reaw3En.html")
	{
		english = 1;
	}
	
	var y = document.cookie.split(';');
	
	devConnected[0].isConnected = false;
	devConnected[1].isConnected = false;
	devConnected[2].isConnected = false;
	devConnected[3].isConnected = false;
	
	list_of_boot_devices[0] = new Device("NONE", false);
	list_of_boot_devices[1] = new Device("CD", false);
	list_of_boot_devices[2] = new Device("USB", false);
	list_of_boot_devices[3] = new Device("HD", false);
	
	document.getElementById('dev1').innerHTML = '';
	
	if(english == 1)
	{
		document.getElementById('dev1').innerHTML += '<h4>Connected Devices</h4>';
	}
	else
	{
		document.getElementById('dev1').innerHTML += '<h4>Dispositivos conectados </h4>';
	}
	
	
	if(y[1] == " dev1=true")
	{
		if(english == 1)
		{
			document.getElementById('dev1').innerHTML += 'Keyboard<br>';
		}
		else
		{
			document.getElementById('dev1').innerHTML += 'Teclado<br>';
		}
		
		devConnected[0].isConnected = true;
	}

	if(y[2] == " dev2=true")
	{
		document.getElementById('dev1').innerHTML += 'Mouse<br>';
		devConnected[1].isConnected = true;
	}
	
	if(y[3] == " dev3=true")
	{
		if(english == 1)
		{
			document.getElementById('dev1').innerHTML += 'Printer<br>';
		}
		else
		{
			document.getElementById('dev1').innerHTML += 'Impressora<br>';
		}
		devConnected[2].isConnected = true;
	}
		
	if(y[4] == " dev4=true")
	{
		document.getElementById('dev1').innerHTML += 'Scanner<br>';
		devConnected[3].isConnected = true;
	}
	
	list_of_basic_devices[0] = devConnected[0];
	list_of_basic_devices[1] = devConnected[1];
	list_of_devices[0] = devConnected[2];
	list_of_devices[1] = devConnected[3];
	list_of_buses[0] = devConnected[2];
	list_of_buses[1] = devConnected[3];
	
	document.getElementById('dev2').innerHTML = '';
	
	
	if(english == 1)
	{
		document.getElementById('dev2').innerHTML += '<h4>Booting devices </h4>';
	}
	else
	{
		document.getElementById('dev2').innerHTML += '<h4>Dispositivo de inicialização </h4>';
	}
	
	
	if(y[0] == "bootDev=NONE")
	{
		bootDevice = "NONE";
		list_of_boot_devices[0].isConnected = true;
		
		if(english == 1)
		{
			document.getElementById('dev2').innerHTML += 'None<br>';
		}
		else
		{
			document.getElementById('dev2').innerHTML += 'Nenhum<br>';
		}
		
	}
	
	if(y[0] == "bootDev=CD")
	{
		bootDevice = "CD";
		list_of_boot_devices[1].isConnected = true;
		document.getElementById('dev2').innerHTML += 'CD-ROM<br>';
	}
	
	if(y[0] == "bootDev=USB")
	{
		bootDevice = "USB";
		list_of_boot_devices[2].isConnected = true;
		document.getElementById('dev2').innerHTML += 'USB drive<br>';
	}
	
	if(y[0] == "bootDev=HD")
	{
		bootDevice = "HD";
		list_of_boot_devices[3].isConnected = true;
		if(english == 1)
		{
			document.getElementById('dev2').innerHTML += 'Hard Disk Drive<br>';
		}
		else
		{
			document.getElementById('dev2').innerHTML += 'Disco rígido<br>';
		}
		
	}
	
	cookies = document.cookie;
}

var printCode = function(line)
{
	var line = parseInt(line);
	document.getElementById('linhas').innerHTML = '';
	document.getElementById('linha0').innerHTML = '<b>' + line + '- </b>' + algorithm[line];
	
	for (var i = line + 1; i < algorithm.length && i < line + 19; ++i)
		document.getElementById('linhas').innerHTML += '<b>' + i + '- </b>' + algorithm[i] + '<br>';
	
	if (algorithm.length - line < 19)
		for (var i = 0; i < (19 - algorithm.length + line); ++i)
			document.getElementById('linhas').innerHTML += '<br>';
	
	if (line == 26 && bootDevice == "NONE")
	{
		var ans;
		
		if (english == 1)
		{
			ans = treatedPrompt("Is there any boot device connected?\n" + 
								"Type the number according to the desired option.\n\n" +
								"    1 - None\n" + 
								"    2 - CD-ROM\n" + 
								"    3 - USB drive\n" + 
								"    4 - Hard Disk Drive\n\n");
		}
		else
		{
			ans = treatedPrompt("Algum dispositivo de inicialização foi conectado?\n" + 
								"Digite o número de acordo com a opção desejada.\n\n" +
								"    1 - Nenhum\n" + 
								"    2 - CD-ROM\n" + 
								"    3 - USB drive\n" + 
								"    4 - Disco rígido\n\n");
		}
		if(ans != '' && ans < 5 && ans > 0)
		{
			switch (ans)
			{
				case "2":
					bootDevice = "CD";
					list_of_boot_devices[1].isConnected = true;
					if(english == 1)
					{
						document.getElementById('dev2').innerHTML = '<h4>Booting devices </h4>';
					}
					else
					{
						document.getElementById('dev2').innerHTML = '<h4>Dispositivo de inicialização </h4>';
					}
					document.getElementById('dev2').innerHTML += 'CD-ROM<br>';
					break;
				case "3":
					bootDevice = "USB";
					list_of_boot_devices[2].isConnected = true;
					if(english == 1)
					{
						document.getElementById('dev2').innerHTML = '<h4>Booting devices </h4>';
					}
					else
					{
						document.getElementById('dev2').innerHTML = '<h4>Dispositivo de inicialização </h4>';
					}
					document.getElementById('dev2').innerHTML += 'USB drive<br>';
					break;
				case "4":
					bootDevice = "HD";
					list_of_boot_devices[3].isConnected = true;
					if(english == 1)
					{
						document.getElementById('dev2').innerHTML = '<h4>Booting devices </h4>';
						document.getElementById('dev2').innerHTML += 'Hard Disk Drive<br>';
					}
					else
					{
						document.getElementById('dev2').innerHTML = '<h4>Dispositivo de inicialização </h4>';
						document.getElementById('dev2').innerHTML += 'Disco rígido<br>';
					}
					break;
				default:
					bootDevice = "NONE";
					list_of_boot_devices[0].isConnected = true;
					break;
			}
		}
		else
		{
			if(english == 1)
			{
				alert("Invalid value! Please insert an integer value between 1 and 4");
			}
			else
			{
				alert("Valor inválida! Por favor, insira um valor inteiro entre 1 e 4");
			}
		}
			
	}
}

var startSimulation = function()
{
	getBootDevice();
	getConnectedDevices();
	cookies = document.cookie;
}

var imgChange = function(thisP)
{
	document.getElementById('imgPanel').innerHTML = "<img src='images/" + thisP + "' />";
}

var chooseNextImage = function()
{
	if(algorithm[currentLine] == " booting_the_computer()")
	{
		imgChange("pc ligando.png");
	}
	if(algorithm[currentLine] == "   installed_RAM_size = memory_testing();")
	{
		imgChange("testmemory.jpg");
	}
	if(algorithm[currentLine] == "   for each (device) in (list_of_basic_devices)"||algorithm[currentLine] == "     if (is_connected(device) == true)"||algorithm[currentLine] == "       test_device(device);")
	{
		imgChange("mousekey.jpg");
	}
	if(algorithm[currentLine] == "   for each (bus) in (list_of_buses)"||algorithm[currentLine] == "     if (connected_device(bus) == NEW_DEVICE)"||algorithm[currentLine] == "       configure_device(bus);")
	{
		imgChange("entradasPCI.jpg");
	}
	if(currentLine == 9 || currentLine == 10)
	{
		imgChange("hdevicesbots.jpg");
	}
	if(algorithm[currentLine] == "  while (!found_device)" || currentLine == 28)
	{
		imgChange("devicesboot.jpg");
	}
	if(algorithm[currentLine] == "  load_boot_sector(boot_device);"||algorithm[currentLine] == "  boot_loader = search_active_partition(boot_device);"||algorithm[currentLine] == "  data = get_configuration_information(BIOS);")
	{
		imgChange("MBR.png");
	}
	if(algorithm[currentLine] == "  init_OS(boot_loader, data);")
	{
		imgChange("ubuntu_load.gif");
	}

	if(algorithm[currentLine] == "  for each (device) in (list_of_devices)")
	{
		imgChange("devicesdrivers.jpg");
	}
	if(algorithm[currentLine] == "    if (driver(device) != INSTALLED)")
	{
		imgChange("notdevicesdrivers.jpg");
	}
	if(algorithm[currentLine] == "  load_in_kernel(drivers);")
	{
		imgChange("loadkernel.jpg");
	}
	if(algorithm[currentLine] == "  initialize_essential_resources();")
	{
		imgChange("desktop.jpg");
	}
	
}

var chooseNextDescription = function()
{
	
	if(english == 1)
	{
		if(algorithm[currentLine] == " booting_the_computer()")//linha 0
		{
			document.getElementById('explicacao').innerHTML = 'The computer in on.<br>';
		}
		
		if(algorithm[currentLine] == "   installed_RAM_size = memory_testing();")//linha 2
		{
			document.getElementById('explicacao').innerHTML = 'The computer checks how much RAM is installed.<br>';
		}
		
		if(algorithm[currentLine] == "   for each (device) in (list_of_basic_devices)")//linha 3
		{
			document.getElementById('explicacao').innerHTML = 'For each device connected in the computer, a test will be made to see if the basic devices are connected. The order for testing the basic devices will be: keyboard, mouse. <br>';
		}
		
		if(algorithm[currentLine] == "     if (is_connected(device) == true)")//linha 4
		{
			document.getElementById('explicacao').innerHTML = 'If there\'s any device connected, this statement is true<br>';
		}
		
		if(algorithm[currentLine] == "       test_device(device);")//linha 5
		{
			document.getElementById('explicacao').innerHTML = 'The test to see if the connected device is working correctly.<br>';
		}
		
		if(algorithm[currentLine] == "   for each (bus) in (list_of_buses)")//linha 6
		{
			document.getElementById('explicacao').innerHTML = 'Now, the BIOS will look in the buses from the PCI Express and PCI to detect all connected devices. The order for testing the connected devices will be: printer, scanner.<br>';
		}
		
		if(algorithm[currentLine] == "     if (connected_device(bus) == NEW_DEVICE)")//linha 7
		{
			document.getElementById('explicacao').innerHTML = 'If a device is connected in the PCIe and PCI buses, then...<br>';
		}
		
		if(algorithm[currentLine] == "       configure_device(bus);")//linha 8
		{
			document.getElementById('explicacao').innerHTML = 'The device will be configured.<br>';
		}
		
		if(algorithm[currentLine] == "   boot_device = null;")//linha 9
		{
			document.getElementById('explicacao').innerHTML = 'In the beggining, the BIOS doesn\'t know where to boot the operational system. It will mark (for now) none as the booting device. <br>';
		}
		
		if(algorithm[currentLine] == "  found_device = false;")//linha 10
		{
			document.getElementById('explicacao').innerHTML = 'Flag to know if a booting device have been found.<br>';
		}
		
		if(algorithm[currentLine] == "  while (!found_device)")//linha 11
		{
			document.getElementById('explicacao').innerHTML = 'The BIOS will determine the booting device from a device list from the CMOS memory. Remember that the boot order can be modified in the BIOS configuration<br>In this case, the booting order will be always the same: CD-ROM, USB drive, Hard Disk Drive';
		}
		
		if(algorithm[currentLine] == "    for each (device) in (list_of_boot_devices)")//linha 13
		{
			document.getElementById('explicacao').innerHTML = 'The BIOS will look for the booting device.<br>';
		}
		
		if(algorithm[currentLine] == "      if (attempt_to_boot(device) == true)")//linha 15
		{
			document.getElementById('explicacao').innerHTML = 'If it\'s possible to boot the operational system from the selected device, then...<br>';
		}
		
		if(algorithm[currentLine] == "        boot_device = device;")//linha 17
		{
			document.getElementById('explicacao').innerHTML = 'A booting device have been found.<br>';
		}
		
		if(algorithm[currentLine] == "        found_device = true;")//linha 18
		{
			document.getElementById('explicacao').innerHTML = 'A booting device have been found. The flag was set to "1" and the "while" will be ignored.<br>';
		}
		
		if(algorithm[currentLine] == "        break;")//linha 19
		{
			document.getElementById('explicacao').innerHTML = 'So the "for" will stop it iterations.<br>';
		}
		
		if(algorithm[currentLine] == "    if (!found_device)")//linha 22
		{
			document.getElementById('explicacao').innerHTML = 'If no booting device have been found...<br>';
		}
		
		if(algorithm[currentLine] == "      print(\"No boot device was found.\");")//linha 24
		{
			document.getElementById('explicacao').innerHTML = 'An error message will be printed on screen.<br>';
		}
		
		if(algorithm[currentLine] == "      print(\"Try again when a boot device is connected.\");")//linha 25
		{
			document.getElementById('explicacao').innerHTML = 'The computer will recommend you, the user, insert a booting device so you can use the computer.<br>';
		}
		
		if(algorithm[currentLine] == "      //ask if there's any boot device connected")//linha 26
		{
			document.getElementById('explicacao').innerHTML = 'A window should appear so the user can insert (optionally) a booting device.<br>';
		}
		
		if(algorithm[currentLine] == "  load_boot_sector(boot_device);")//linha 29
		{
			document.getElementById('explicacao').innerHTML = 'The BIOS will read the MBR (Master Boot Record), that will be in the sector 0 from the device. In the end of the MBR, a table can be found that have the start and the end of each partition. Only one partition is selected as "active".<br>';
		}
		
		if(algorithm[currentLine] == "  boot_loader = search_active_partition(boot_device);")//linha 30
		{
			document.getElementById('explicacao').innerHTML = 'The first thing that the MBR does is to locate the only active partition. The first block of it is called "boot block". When it is executed, the operational system is loaded from this partition<br>For uniformity, every partition will start with a boot block, even if it doesn\'t have an operational system (maybe in the future?) ';
		}
		
		if(algorithm[currentLine] == "  data = get_configuration_information(BIOS);")//linha 31
		{
			document.getElementById('explicacao').innerHTML = 'The BIOS will try to get the information from the configuration of the connected devices<br>';
		}
		
		if(algorithm[currentLine] == "  init_OS(boot_loader, data);")//linha 32
		{
			document.getElementById('explicacao').innerHTML = 'In this moment, the "boot_loader" will read the operational system from the active partition and it will start.<br>';
		}
		
		if(algorithm[currentLine] == "  for each (device) in (list_of_devices)")//linha 33
		{
			document.getElementById('explicacao').innerHTML = 'Now, the BIOS will verify if every connected device have an installed driver. In this case, the sequence of devices to be checked will be: printer, scanner. <br>';
		}
		
		if(algorithm[currentLine] == "    if (driver(device) != INSTALLED)")//linha 34
		{
			document.getElementById('explicacao').innerHTML = 'If the BIOS finds a driver that is not installed...<br>';
		}
		
		if(algorithm[currentLine] == "      print(\"Install the driver from: CD-ROM or Internet.\");")//linha 35
		{
			document.getElementById('explicacao').innerHTML = '...it will tell you to install it!<br>';
		}
		
		if(algorithm[currentLine] == "  load_in_kernel(drivers);")//linha 36
		{
			document.getElementById('explicacao').innerHTML = 'After the BIOS finds then, the operational system will send the drivers to the kernel<br>';
		}
		
		if(algorithm[currentLine] == "  initialize_essential_resources();")//linha 37
		{
			document.getElementById('explicacao').innerHTML = 'The essential resources, like tables and background process, will start. In the end, the login program or the GUI will start.<br>';
		}

	}
	else
	{
		if(algorithm[currentLine] == " booting_the_computer()")//linha 0
		{
			document.getElementById('explicacao').innerHTML = 'O computador foi ligado.<br>';
		}
		
		if(algorithm[currentLine] == "   installed_RAM_size = memory_testing();")//linha 2
		{
			document.getElementById('explicacao').innerHTML = 'O computador checa quanto de memória RAM está instalado.<br>';
		}
		
		if(algorithm[currentLine] == "   for each (device) in (list_of_basic_devices)")//linha 3
		{
			document.getElementById('explicacao').innerHTML = 'Para cada dispositivo que estiver conectado no computador, um teste será feito para ver se os dispositivos básicos estão funcionando. A ordem para testar os dispositivos básicos será: teclado, mouse.<br>';
		}
		
		if(algorithm[currentLine] == "     if (is_connected(device) == true)")//linha 4
		{
			document.getElementById('explicacao').innerHTML = 'Se algum certo dispositivo estiver conectado, essa afirmação será verdadeira.<br>';
		}
		
		if(algorithm[currentLine] == "       test_device(device);")//linha 5
		{
			document.getElementById('explicacao').innerHTML = 'O teste para ver se o dispositivo conectado está funcionando corretamente.<br>';
		}
		
		if(algorithm[currentLine] == "   for each (bus) in (list_of_buses)")//linha 6
		{
			document.getElementById('explicacao').innerHTML = 'Agora a BIOS procura os barramentos do PCI Express e do PCI para detectar todos os dispositivos conectados. A ordem para testar os dispositivos conectados será: impressora, scanner.<br>';
		}
		
		if(algorithm[currentLine] == "     if (connected_device(bus) == NEW_DEVICE)")//linha 7
		{
			document.getElementById('explicacao').innerHTML = 'Se um dispositivo conectado no barramento de PCIe ou do PCI for novo, então...<br>';
		}
		
		if(algorithm[currentLine] == "       configure_device(bus);")//linha 8
		{
			document.getElementById('explicacao').innerHTML = 'O dispositivo será configurado.<br>';
		}
		
		if(algorithm[currentLine] == "   boot_device = null;")//linha 9
		{
			document.getElementById('explicacao').innerHTML = 'De início, a BIOS não sabe por onde ela irá iniciar o sistema operacional, então ela marcará (temporariamente) nenhum como dispositivo de inicialização.<br>';
		}
		
		if(algorithm[currentLine] == "  found_device = false;")//linha 10
		{
			document.getElementById('explicacao').innerHTML = 'Flag para saber se um dispositivo de inicialização foi encontrado.<br>';
		}
		
		if(algorithm[currentLine] == "  while (!found_device)")//linha 11
		{
			document.getElementById('explicacao').innerHTML = 'A BIOS irá determinar o dispositivo de inicialização pela lista de dispositivos guardada na memória CMOS. Lembrando que a ordem do boot poderá ser modificada pela configuração da BIOS<br>Nesse caso, a ordem de inicialização será constante: CD-ROM, USB drive, disco rígido.';
		}
		
		if(algorithm[currentLine] == "    for each (device) in (list_of_boot_devices)")//linha 13
		{
			document.getElementById('explicacao').innerHTML = 'A BIOS irá procurar o dispositivo de inicialização.<br>';
		}
		
		if(algorithm[currentLine] == "      if (attempt_to_boot(device) == true)")//linha 15
		{
			document.getElementById('explicacao').innerHTML = 'Se for possível realizar a inicialização do sistema operacional pelo dispositivo selecionado, então...<br>';
		}
		
		if(algorithm[currentLine] == "        boot_device = device;")//linha 17
		{
			document.getElementById('explicacao').innerHTML = 'Um dispositivo de inicialização foi encontrado.<br>';
		}
		
		if(algorithm[currentLine] == "        found_device = true;")//linha 18
		{
			document.getElementById('explicacao').innerHTML = 'Um dispositivo de inicialização foi encontrado. Então a flag foi "setada" e o "while" será ignorado.<br>';
		}
		
		if(algorithm[currentLine] == "        break;")//linha 19
		{
			document.getElementById('explicacao').innerHTML = 'Para que o "for" pare de fazer iterações.<br>';
		}
		
		if(algorithm[currentLine] == "    if (!found_device)")//linha 22
		{
			document.getElementById('explicacao').innerHTML = 'Se nenhum dispositivo de inicialização foi encontrado...<br>';
		}
		
		if(algorithm[currentLine] == "      print(\"No boot device was found.\");")//linha 24
		{
			document.getElementById('explicacao').innerHTML = 'Uma mensagem de erro será impressa na tela.<br>';
		}
		
		if(algorithm[currentLine] == "      print(\"Try again when a boot device is connected.\");")//linha 25
		{
			document.getElementById('explicacao').innerHTML = 'O próprio computador vai recomendar que você, mero usuário, coloque um dispositivo de inicialização para que você possa usar o computador.<br>';
		}
		
		if(algorithm[currentLine] == "      //ask if there's any boot device connected")//linha 26
		{
			document.getElementById('explicacao').innerHTML = 'Uma janela deve aparecer para que o usuário insira (opcionalmente) um dispositivo de inicialização.<br>';
		}
		
		if(algorithm[currentLine] == "  load_boot_sector(boot_device);")//linha 29
		{
			document.getElementById('explicacao').innerHTML = 'A  BIOS irá ler o MBR (Master Boot Record), que estará no setor 0 do dispositivo. No final do MBR, é encontrado uma tabela que tem o início e o fim de cada partição. Apenas uma das partições está selecionada como "ativa".<br>';
		}
		
		if(algorithm[currentLine] == "  boot_loader = search_active_partition(boot_device);")//linha 30
		{
			document.getElementById('explicacao').innerHTML = 'A primeira coisa que o MBR faz é localizar a única partição que está ativa. O primeiro bloco desta é chamado de "boot block". Quando ela é executada, o sistema operacional é carregado desta partição<br>Para uniformidade, toda partição começa com um boot block, mesmo se ela não tiver um sistema operacional(no futuro ela pode ter)';
		}
		
		if(algorithm[currentLine] == "  data = get_configuration_information(BIOS);")//linha 31
		{
			document.getElementById('explicacao').innerHTML = 'A BIOS tenta adquirir as informações de configuração dos dispositivos conectados (drivers).<br>';
		}
		
		if(algorithm[currentLine] == "  init_OS(boot_loader, data);")//linha 32
		{
			document.getElementById('explicacao').innerHTML = 'Nesse momento, o "boot_loader" lê o sistema operacional da partição ativa e o inicia.<br>';
		}
		
		if(algorithm[currentLine] == "  for each (device) in (list_of_devices)")//linha 33
		{
			document.getElementById('explicacao').innerHTML = 'Agora, a BIOS vai verificar se todos os dispositivos conectados tem um driver instalado. Nesse caso, a sequência de dispositivos a serem verificados será: impressora, scanner.<br>';
		}
		
		if(algorithm[currentLine] == "    if (driver(device) != INSTALLED)")//linha 34
		{
			document.getElementById('explicacao').innerHTML = 'Se a BIOS encontrar algum que não tenha o driver instalado...<br>';
		}
		
		if(algorithm[currentLine] == "      print(\"Install the driver from: CD-ROM or Internet.\");")//linha 35
		{
			document.getElementById('explicacao').innerHTML = '...ela vai dizer para você instalar!<br>';
		}
		
		if(algorithm[currentLine] == "  load_in_kernel(drivers);")//linha 36
		{
			document.getElementById('explicacao').innerHTML = 'Após a BIOS encontrar, o sistema operacional vai enviar os drivers para o kernel.<br>';
		}
		
		if(algorithm[currentLine] == "  initialize_essential_resources();")//linha 37
		{
			document.getElementById('explicacao').innerHTML = 'Os recursos essenciais, como tabelas e processos em segundo plano são inicializados. Por fim, é inicializado o programa de identificação do usuário ou o GUI.<br>';
		}

	}
	
}

var goToLine = function()
{
	var n;
	n = treatedPrompt("Para qual linha você deseja ir?");
	if (n != '' && n < algorithm.length && n >= 0)
	{
		currentLine = n - 1;
		nextLine();
	}
	else
		if(english == 1)
		{
			alert("Invalid value! Please insert an integer value between 1 and " + (algorithm.length - 1));
		}
		else
		{
			alert("Valor inválida! Por favor, insira um valor inteiro entre 0 e " + (algorithm.length - 1));
		}
		
}

var treatedPrompt = function(str)
{
	var n = prompt(str);
	if (n != null && n.trim() != '' && isNaN(n) == false && n == parseInt(n, 10))
		return (n);
	else
		return '';
}

var goToLine0 = function()
{
	list_states = new Array();
	selectedConfiguration();
	currentLine = -1;
	nextLine();
	document.getElementById("botaoVoltar").disabled = true;
}

var changeScale = function()
{
	if(scale == 0)
	{
		document.getElementById("explicacaoDiv").style.resize = "both";
		document.getElementById("imgPanel").style.resize = "both";
		scale = 1;
	}
	else
	{
		document.getElementById("explicacaoDiv").style.resize = "initial";
		document.getElementById("imgPanel").style.resize = "initial";
		document.getElementById("imgPanel").style.width = "initial";
		document.getElementById("explicacaoDiv").style.width = "initial";
		document.getElementById("imgPanel").style.height = "initial";
		document.getElementById("explicacaoDiv").style.height = "initial";
		scale = 0;
	}
}

var nextLine = function()
{
	console.log("NEXT--currentDevice:" + currentDevice);
	if (currentLine < algorithm.length - 1)
	{
		currentLine = getNextLine(currentLine);
		printCode(currentLine);
		saveState(currentLine);
		
		if (currentLine == algorithm.length - 1)
			document.getElementById("botaoProximo").disabled = true;
		else
			document.getElementById("botaoProximo").disabled = false;
		
		document.getElementById("botaoVoltar").disabled = false;
		
		chooseNextImage();
		chooseNextDescription();
	}
	else
		document.getElementById("botaoProximo").disabled = true;
}

var getNextLine = function(line)
{
	if (line === 4)
	{
		if (!list_of_basic_devices[currentDevice].isConnected)
		{
			if (currentDevice == 0)
				return (3);
			else if (currentDevice == 1)
				return (6); 
		}
		else
			return (5);
	}
	else if (line == 5)
	{
		if (currentDevice == 0)
			return (3);
		else if (currentDevice == 1)
			return (6);
	}
	else if (line == 7)
	{
		if (!list_of_buses[currentBus].isConnected)
		{
			if (currentBus == 0)
				return (6);
			else if (currentBus == 1)
				return (9);
		}
		else
			return (8);
	}
	else if (line == 8)
	{
		if (currentBus == 0)
			return (6);
		else if (currentBus == 1)
			return (9);
	}
	else if (line == 15)
	{
		if (!list_of_boot_devices[currentDevice].isConnected)
		{
			if (currentDevice == 3)
				return (21);
			else
				return (13);
		}
		else
			return (16);
	}
	else if (line == 19)
	{
		return (21);
	}
	else if (line == 22)
	{
		if ((list_states[currentState - 3] instanceof Array && list_states[currentState - 3] == 18) 
			|| (list_states[currentState - 3].line == 18))
			return (27);
		else
			return (23);
	}
	else if (line == 26)
	{
		return (11);
	}
	if (line === 34)
	{
		if (!list_of_devices[currentDevice].isConnected)
		{
			if (currentDevice == 0)
				return (33);
			else if (currentDevice == 1)
				return (36); 
		}
		else
			return (35);
	}
	else if (line == 35)
	{
		if (currentDevice == 0)
			return (33);
		else if (currentDevice == 1)
			return (36);
	}
	else
		return (parseInt(line) + 1);
}

var saveState = function(line)
{
	++currentState;
	if (line == 3 || line == 33)
	{
		currentDevice = (currentDevice + 1) % 2;
		list_states[currentState] = new LineDevice(line, currentDevice);
	}
	else if (line == 13)
	{
		currentDevice = (currentDevice + 1) % 4;
		list_states[currentState] = new LineDevice(line, currentDevice);
	}
	else if (line == 4 || line == 5 || line == 34 || line == 35 ||
	line == 15 || line == 17 || line == 18 || line == 19)
	{
		list_states[currentState] = new LineDevice(line, currentDevice);
	}
	else if (line == 6)
	{
		currentBus = (currentBus + 1) % 2;
		list_states[currentState] = new LineBus(line, currentBus);
	}
	else if (line == 7 || line == 8)
	{
		list_states[currentState] = new LineBus(line, currentBus);
	}
	else if (line == 11)
	{
		currentDevice = 0;
		list_states[currentState] = new LineDevice(line, currentDevice);
	}
	else if (line <= 32 && line >= 29)
	{
		currentDevice = -1;
		list_states[currentState] = new BootDevice(line, bootDevice);
	}
	else if (algorithm[line].charAt(algorithm[line].length - 1) == '{'
	|| algorithm[line].charAt(algorithm[line].length - 1) == '}')
	{
		if (list_states[currentState - 1] instanceof Array)
		{
			list_states[currentState] = [line];
		}
		else
		{
			list_states[currentState] = Object.create(list_states[currentState - 1]);
			list_states[currentState].line = line;
		}
	}
	else
	{
		list_states[currentState] = [line];
	}
}

var previousLine = function()
{		
	console.log("PREV--currentDevice:" + currentDevice);
	if(currentState >= 0 && list_states.length > 0)
	{
		currentState--;
		getState(currentState);		
		printCode(currentLine);
		
		document.getElementById("botaoVoltar").disabled = false;
		document.getElementById("botaoProximo").disabled = false;
	}
	else
		document.getElementById("botaoVoltar").disabled = true;
	
	chooseNextImage();
	chooseNextDescription();
}

var getState = function(currentState)
{
	if (list_states[currentState] instanceof Array)
		currentLine = list_states[currentState];
	else
	{
		currentLine = list_states[currentState].line;
		
		if (list_states[currentState] instanceof BootDevice)
			bootDevice = list_states[currentState].device;
		
		else if (list_states[currentState] instanceof LineBus)
			currentBus = list_states[currentState].bus;
		
		else 
			currentDevice = list_states[currentState].device;
	}
}


window.onload = printCode(0);
window.onload = selectedConfiguration();
window.onload = goToLine0();
